package com.dapr.service.controller;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Mono;

import java.io.IOException;
import java.util.Map;

@RestController
public class DeleteController extends CommonController {

    @PostMapping(path = "/delete")
    public Mono<String> handleMethod(@RequestBody(required = false) byte[] body,
                                     @RequestHeader Map<String, String> headers) {
        return Mono.fromSupplier(() -> {
            try {
                // message="{\"id\": \"%s\"}";
                String message = setBody(body, headers);
                delete(message);
                return message + " received";
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        });
    }

    private void delete(String body) throws IOException {

        // 提取参数
        JSONObject jsonObject = JSONObject.parseObject(body);
        String id = jsonObject.getString("id");
        System.out.println("Id: " + id);

        //拼接SQL
        String bodyTmpl = "{\"operation\": \"exec\",\"metadata\": {\"sql\": \"Delete FROM feedback where id = \\\"%s\\\" \" }}";
        String sql =String.format(bodyTmpl, id);

        // 请求mysql
      //  doMysqlPost(sql);

        // 请求MQ
        sendExecMsg("删除完毕");
    }
}
