package com.dapr.service.controller;

import com.alibaba.fastjson.JSONObject;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RestController;
import reactor.core.publisher.Mono;

import java.io.IOException;
import java.util.Map;

@RestController
public class SelectController extends CommonController {

    @PostMapping(path = "/select")
    public Mono<String> handleMethod(@RequestBody(required = false) byte[] body,
                                     @RequestHeader Map<String, String> headers) {
        return Mono.fromSupplier(() -> {
            try {
                // message="{\"id\": \"%s\"}";
                String message = setBody(body, headers);
                select(message);
                return message + " received";
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        });
    }

    private void select(String body) throws IOException {

        // 提取参数
        JSONObject jsonObject = JSONObject.parseObject(body);
        String id = jsonObject.getString("id");
        System.out.println("Id: " + id);

        //拼接SQL
        String bodyTmpl = "{\"operation\": \"query\",\"metadata\": {\"sql\": \"SELECT * FROM feedback where id = \\\"%s\\\" \" }}";
        String sql =String.format(bodyTmpl, id);


        // 请求MQ
        sendQueryMsg(sql);
    }
}
